<template>
  <div class="text-right">
    <v-dialog v-model="dialog" persistent height="auto" width="900">
      <template v-slot:activator="{ on, attrs }">
        <v-btn
          class="
            button-text
            v-btn v-btn--outlined v-btn--rounded
            theme--light
            v-size--default
            tway-violet--text
          "
          color="coral lighten-2"
          outlined
          v-bind="attrs"
          v-on="on"
        >
          <v-icon color="purple"> mdi-cog-outline </v-icon>
          CONFIGURACIÓN
        </v-btn>
      </template>
      <v-card :class="'modalSystem'">
        <v-btn icon right @click="dialog = false" class="float-right">
          <v-icon>mdi-close</v-icon>
        </v-btn>
        <v-card>
          <div class="container">
            <h3 class="text-center">CONFIGURACIÓN DE RIESGOS</h3>
            <h4 class="text-center font-weight-regular">
              Dimensiones de Riesgos
            </h4>
            <!-- <v-card elevation="1" shaped>
              <v-card-title>{{ setup.name }} ( {{ setup.code }} )</v-card-title>
              <v-card-text>
                <v-row align="center" class="mx-0">
                  <div class="my-2 text-subtitle-1">
                    La fecha propuesta comienza el
                    {{ setup.humanStartDateProposal }} y términa el
                    {{ setup.humanEndDateProposal }}
                  </div>
                </v-row>
              </v-card-text>
            </v-card> -->
            <form>
              <div class="d-flex justify-space-between mt-2">
                <v-row class="mt-6">
                  <v-col md="6">
                    <v-text-field
                      label="Nombre Dimensión de Riesgo 1"
                      :hide-details="true"
                      :maxlength="'15'"
                      :minlenght="'0'"
                      type="text"
                      outlined
                    />
                  </v-col>
                  <v-col md="6">
                    <v-text-field
                      label="Nombre Dimensión de Riesgo 2"
                      :hide-details="true"
                      :maxlength="'15'"
                      :minlenght="'0'"
                      type="text"
                      outlined
                    />
                  </v-col>
                  <v-col md="6">
                    <v-text-field
                      label="Nombre Dimensión de Riesgo 3"
                      :hide-details="true"
                      :maxlength="'15'"
                      :minlenght="'0'"
                      type="text"
                      outlined
                    />
                  </v-col>
                  <v-col md="6">
                    <v-text-field
                      label="Nombre Dimensión de Riesgo 4"
                      :hide-details="true"
                      :maxlength="'15'"
                      :minlenght="'0'"
                      type="text"
                      outlined
                    />
                  </v-col>
                  <v-col md="6">
                    <v-text-field
                      label="Nombre Dimensión de Riesgo 5"
                      :hide-details="true"
                      :maxlength="'15'"
                      :minlenght="'0'"
                      type="text"
                      outlined
                    />
                  </v-col>
                  <v-col
                    md="12"
                    class="
                      text-center
                      d-flex
                      justify-center
                      pa-md-10
                      mx-lg-auto
                    "
                  >
                    <v-btn
                      class="
                        button-text
                        v-btn v-btn--outlined v-btn--rounded
                        theme--light
                        v-size--default
                        tway-violet--text
                      "
                      outlined
                      color="indigo lighten-2"
                      @click="
                        saveProject;
                        dialog = false;
                      "
                    >
                      <v-icon color="purple"> mdi-content-save </v-icon>
                      Guardar Dimensiones
                    </v-btn>
                  </v-col>
                </v-row>

                <!-- <date-vuetify
                  label="Inicio"
                  v-model="startDateProposal"
                ></date-vuetify>
                <date-vuetify
                  label="Termino"
                  v-model="endDateProposal"
                ></date-vuetify>
                <v-btn outlined color="indigo" @click="saveProject">
                  Guardar Proyecto
                </v-btn> -->
              </div>
            </form>
            <!-- ETAPAS -->
          </div>
        </v-card>

        <!-- <v-divider></v-divider>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" text @click="closeConfigurationDialog()">
            Actualizar y Cerrar.
          </v-btn>
        </v-card-actions> -->
      </v-card>
    </v-dialog>
    <confirmation
      ref="confirm"
      :message="dialogMessage.title"
      :message-body="dialogMessage.body"
    ></confirmation>
  </div>
</template>

<script>
import BudgetService from "@/services/pmo/budget/budgetService";
import PlanificationService from "@/services/pmo/planification/planificationService";
import Confirmation from "../utils/ConfirmationDialog.vue";

export default {
  components: { Confirmation },
  data: (vm) => {
    return {
      on: false,
      dialogMessage: {
        title: "",
        body: "",
      },
      dateFormatted: vm.formatDate(
        new Date(Date.now() - new Date().getTimezoneOffset() * 60000)
          .toISOString()
          .substr(0, 10)
      ),
      loading: {
        saveStage: false,
        saveActivity: false,
      },
      alert: {
        saveStage: false,
        saveActivity: false,
      },
      messageError: {
        saveStage: "",
        saveActivity: "",
      },
      activity: {
        stageSelected: 0,
        name: "",
        dateStart: "",
        dateEnd: "",
        responsableSelected: 0,
      },
      stage: {
        name: "",
        dateStart: "",
        dateEnd: "",
      },
      dialog: false,
      menu: false,
      modal: false,
      menu1: false,
      menu2: false,
      menu3: false,
      menu4: false,
      menu5: false,
      startDateProposal: "",
      endDateProposal: "",
      etapas: [],
      combos: {
        selectEtapas: [],
        responsible: [],
      },
      setup: null,
      activities: [],
    };
  },
  watch: {
    date() {
      this.dateFormatted = this.formatDate(this.date);
    },
  },
  computed: {
    sortedList: function () {
      return this.allScores.slice().sort(function (a, b) {
        return b.score - a.score;
      });
    },
    sortedList2: function () {
      return this.allScor.slice().sort(function (a, b) {
        return b.score - a.score;
      });
    },
    computedStartDateProposal() {
      return this.formatDate(this.setup.startDateProposal);
    },
    computedStageDateStart() {
      return this.formatDate(this.stage.dateStart);
    },
    computedStageDateEnd() {
      return this.formatDate(this.stage.dateEnd);
    },
    computedDateFormatted5() {
      return this.formatDate(this.activity.dateStart);
    },
    computedDateFormatted6() {
      return this.formatDate(this.activity.dateEnd);
    },
    computedEndDateProposal(val) {
      return val;
    },
  },
  methods: {
    closeConfigurationDialog() {
      this.dialog = false;
      this.$emit("reloadPlanificationCharts");
    },
    formatDate(date) {
      if (!date) return null;

      const [year, month, day] = date.split("-");
      return `${day}/${month}/${year}`;
    },
    saveProject() {},
    saveStage() {
      let test = {
        proyectoId: this.setup.id,
        orden: 2,
        nombre: "Bob",
        etapa: this.stage.name,
        inicio: this.formatDate(this.stage.dateStart),
        termino: this.formatDate(this.stage.dateEnd),
      };

      this.loading.saveStage = true;

      PlanificationService.saveStage(test)
        .then(() => {
          BudgetService.stages()
            .then((data) => {
              this.etapas = data;
            })
            .catch((err) => console.dir(err));

          BudgetService.stagesInExistence()
            .then((data) => {
              this.combos.selectEtapas = data;
            })
            .catch((err) => console.dir(err));
        })
        .catch((err) => {
          let message = err.response.data.message;
          this.alert.saveStage = true;
          this.messageError.saveStage = message;
          console.dir(err);
        })
        .finally(() => {
          this.loading.saveStage = false;
          setTimeout(() => (this.alert.saveStage = false), 4000);
          this.clearForm();
        });
    },
    saveActivity() {
      let test = {
        proyectoId: this.setup.id,
        orden: 2,
        nombre: this.activity.name,
        etapaId: this.activity.stageSelected,
        responsableId: this.activity.responsableSelected,
        inicio: this.activity.dateStart,
        termino: this.activity.dateEnd,
      };

      this.loading.saveActivity = true;

      PlanificationService.saveActivity(test)
        .then(() => {
          PlanificationService.getActivities()
            .then((data) => {
              console.dir(data);
              this.activities = data;
            })
            .catch((err) => console.dir(err));
        })
        .catch((err) => {
          let message = err.response.data.message;
          this.alert.saveActivity = true;
          this.messageError.saveActivity = message;
          console.dir(err);
        })
        .finally(() => {
          this.loading.saveActivity = false;
          setTimeout(() => (this.alert.saveActivity = false), 4000);
          this.clearForm();
        });
    },
    clearForm() {},
    deleteStage(entry) {
      this.dialogMessage.title = "¿Está seguro de eliminar esta etapa?";
      this.dialogMessage.body =
        "Esta acción eliminará todas las actividades asociadas a esta etapa";
      console.dir(this.$refs);

      const veamos = this.$refs.confirm.open();

      veamos.then(() => {
        PlanificationService.deleteStage(entry.id)
          .then(() => {
            PlanificationService.stages()
              .then((data) => {
                this.etapas = data;
              })
              .catch((err) => console.dir(err));

            PlanificationService.stagesInExistence()
              .then((data) => {
                this.combos.selectEtapas = data;
              })
              .catch((err) => console.dir(err));
          })
          .catch((err) => console.dir(err))
          .finally(() => {});
      });
    },
    deleteActivity(entry) {
      PlanificationService.deleteActivity(entry.id)
        .then(() => {
          PlanificationService.getActivities()
            .then((data) => {
              this.activities = data;
            })
            .catch((err) => console.dir(err));
        })
        .catch((err) => console.dir(err));
    },
  },
  mounted() {
    this.clearForm();

    PlanificationService.setup()
      .then((data) => {
        console.dir(data);
        this.setup = data;
      })
      .catch((err) => console.dir(err));

    PlanificationService.getActivities()
      .then((data) => {
        console.dir(data);
        this.activities = data;
      })
      .catch((err) => console.dir(err));

    BudgetService.stages()
      .then((data) => {
        this.etapas = data;
      })
      .catch((err) => console.dir(err));

    PlanificationService.stagesInExistence()
      .then((data) => {
        this.combos.selectEtapas = data;
      })
      .catch((err) => console.dir(err));

    PlanificationService.getResponsible()
      .then((data) => {
        this.combos.responsible = data;
      })
      .catch((err) => console.dir(err));
  },
};
</script>

<style>
.shrink {
  width: 150px;
}
.bar {
  width: 350px;
}
.modalSystem {
  border-radius: 0px !important;
}
.v-menu__content.theme--light.v-menu__content--fixed.menuable__content__active {
  background-color: #fff;
}
.modalSystem .v-card.v-sheet.theme--light {
  padding: 20px 40px;
}
.modalSystem label.v-label.theme--light {
  font-family: "Josefin Sans", sans-serif !important;
}
.modalSystem fieldset {
  border-color: #4a148c !important;
}
.modalSystem label.v-label--active {
  color: #4a148c !important;
}
.modalSystem button.float-right {
  z-index: 9;
  top: 15px;
  right: 15px;
  position: absolute;
}
</style>
